#ifndef _lsmp_rw
#define _lsmp_rw

#include <stdlib.h>
#include <stdint.h>
#include "lsmp.hh"
#include "lsmp_prod.hh"
#include "lsmp_con.hh"

class ShmWriter {
public:
    ShmWriter();
    ~ShmWriter();
    const bool connect(const char *name, const int num_buffers, const int blocksize, const int buffer_mode);
    const int write_data(std::string write_data_bytes, const unsigned long timestamp) const;
    const bool has_crc(const std::string data) const;
    const bool check_crc(const std::string data) const;
private:
    std::string partition_name;
    LSMP_PROD *partition;
};

class ShmReader {
public:
    ShmReader();
    ~ShmReader();
    const bool connect(const char *name);
    void read_data(int& read_data_ret, std::string& read_data_bytes, unsigned long& read_data_timestamp);
    const bool has_crc(const std::string data);
    const bool check_crc(const std::string data);

private:
    std::string partition_name;
    LSMP_CON *partition;
};

class ShmKill {
public:
    int kill(const char* name);
};

#endif
